﻿Type=Class
Version=2.26
@EndOfDesignText@
'Class module
'--------------------------------------------
' Class Module tvrage2
' Copyright © 2012 by RainyDay Solutions
' Written for Learning Basic4Android (working title)
'--------------------------------------------
Sub Class_Globals
	'-----------------------------
	Dim NameSearch As HttpJob
	Dim ShowInformationJob As HttpJob
	Dim EpisodeInformationJob As HttpJob
	'-----------------------------
	Dim parser As SaxParser
	Dim APIKey As String
	Dim FindSeriesString As String
	Dim GetShowInfoString As String
	Dim GetEpisodeListString As String
	Dim GetFullScheduleString As String	
	
	Dim WhichJob As String
	
	Dim ShowList As List 'Show name list of map objects.
	Dim ShowInfo As List 'Show information
	Dim EpisodeList As List 
	Dim SeasonList As List
	
	Dim ShowIdStr, ShowName As String
	Dim link, seasons, image, started, startdate, ended, status, classification,origincountry As String
	Dim summary, genres, runtime, network, airday, airtime,seriescountry As String
	Dim genrestemp As String
	Dim EpiList As EpisodeListType
	'Dim EpisodeSeason, EpisodeEpnum, EpisodeSeasonnum, EpisodeProdnum, EpisodeAirdate, EpisodeLink, EpisodeTitle, EpisodeSummary, EpisodeRating, EpisodeScreenCap,EpisodeAirTime  As String
	Dim EpType, EpSeason, EpNumber, EpSeasonNumber, EpProductionNumber, EpAirDate, EpLink, EpTitle, EpSummary, EpRating, EpScreenCap, EpAlternateAirTime As String
	Dim CurrentSeason As Int
	Dim SpecialFlag As Boolean
	Dim MovieFlag As Boolean
	Dim HasSpecials As Boolean
	Dim InternalEpNum As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	APIKey = "Itnl8IyY1hsR9n0IP6zI"	
	FindSeriesString = "http://services.tvrage.com/myfeeds/search.php?key="
	GetShowInfoString = "http://services.tvrage.com/myfeeds/showinfo.php?key="
    GetEpisodeListString = "http://services.tvrage.com/myfeeds/episode_list.php?key="
    GetFullScheduleString = "http://services.tvrage.com/myfeeds/fullschedule.php?key="	
	
	NameSearch.Initialize("NameSearch",Me)
	ShowInformationJob.Initialize("ShowInformation",Me)
	EpisodeInformationJob.Initialize("EpisodeInformation",Me)
	parser.Initialize
	
	ShowList.Initialize
	ShowInfo.Initialize
	EpisodeList.Initialize
	EpiList.Initialize
	CurrentSeason = 1
	SeasonList.Initialize
	SpecialFlag = False
	MovieFlag = False
End Sub

'Gets the Show ID from the showname
Public Sub QueryForShowID(TheShowName As String)
	'-----------------------------
	Dim SendString As String
	'-----------------------------
	'Log(TheShowName)
	If TheShowName.IndexOf(" ") > -1 Then
		TheShowName = TheShowName.Replace(" ","+")
	End If
	'Log(TheShowName)
	WhichJob = "NameSearch"	
	SendString = FindSeriesString & APIKey & "&show=" & TheShowName
	'Log("Sending String - " & SendString)
	NameSearch.Download(SendString)
End Sub

'Gets Series information from show id 
Public Sub QueryForShowInfo(Showid As String)
	'-----------------------------
	Dim SendString As String
	'-----------------------------
	WhichJob = "ShowInfo"
	SendString = GetShowInfoString & APIKey & "&sid=" & Showid
	'Log("Sending String - " & SendString)
	ShowInformationJob.Download(SendString)
End Sub

Public Sub QueryForEpisodeInfo(Showid As String)
	'-----------------------------
	Dim SendString As String
	'-----------------------------
	WhichJob = "EpisodeInfo"
	SendString = GetEpisodeListString & APIKey & "&sid=" & Showid
	'Log("Sending String - " & SendString)
	EpisodeInformationJob.download(SendString)
End Sub

Public Sub JobDone (Job As HttpJob)
	'-----------------------------
	Dim j As InputStream
	Dim cntr As Int
	Dim lst As List
	Dim res As Map
	'-----------------------------
	res.Initialize
	lst.Initialize
	'Log("HasSpecials = " & HasSpecials)
	'Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	If Job.Success = True Then
		Select Job.JobName
			Case "NameSearch" 
				j = Job.GetInputStream
				ShowList.Clear				
				'Log(j)
				ClearElements
				parser.Parse(j, "parser")
				If ShowList.Size > 0 Then
					CallSubDelayed3(Main,"SearchResponse",True,ShowList)
				Else
					CallSubDelayed3(Main,"SearchResponse",False,ShowList)
				End If
			Case "ShowInformation"
				j = Job.GetInputStream
				'Log(j)
				ShowInfo.Clear
				parser.Parse(j, "parser")
				CallSubDelayed3(Main,"InfoResponse",True,ShowInfo)				
			Case "EpisodeInformation"
				j = Job.GetInputStream
				'Log(j)
				EpisodeList.Clear
				parser.Parse(j, "parser")
				'put the last season episode information into the seasonlist list
				'Log("Episode List size is " & EpisodeList.Size)
				'Log(EpisodeList)
				SeasonList.Add(EpisodeList)
				File.WriteList(File.DirRootExternal,"seasonlist.txt",SeasonList)
				CallSubDelayed3(Main,"EpisodeResponse",True,SeasonList)					
		End Select
	Else
		'Log("Error: " & Job.ErrorMessage)
		CallSubDelayed3(Main,"SearchResponse",False,Null)
	End If
	Job.Release
End Sub

Sub ClearShowInfoVars
	ShowIdStr = ""
	ShowName = ""
	link = ""
	seasons = ""
	image = ""
	status = ""
	started = ""
	startdate = ""
	ended = ""
	origincountry = ""
	seriescountry = ""
	classification = ""
	summary = ""
	genres = ""
	genrestemp = ""
	runtime = ""
	network = ""
	airday = ""
	airtime = ""
	'Log("End of clearing")
End Sub

' StartElement <Name> - At beginning of each Element the Parser calls this Sub
Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
	'-----------------------------
	Dim cnt As Int
	Dim attrib As Attributes
	Dim nam,val As String
	'-----------------------------
	If Name = "Showinfo" Then
		ClearShowInfoVars
	End If
	If parser.Parents.IndexOf("Episodelist") > -1 Then
		If Name = "Season" Then		
			nam = Attributes.GetName(0)
			val = Attributes.GetValue(0)
			If nam = "no" Then
				If val <> CurrentSeason Then
					If EpisodeList.Size > 0 Then
						SeasonList.Add(EpisodeList)
						EpisodeList.Initialize
						EpisodeList.Clear
					End If
				End If
				CurrentSeason = val
			End If
		Else If Name = "Special" Then
			CurrentSeason = 0
			SpecialFlag = True
			HasSpecials = True
			InternalEpNum = 0
			Main.SeriesHasSpecials = True
			If EpisodeList.Size > 0 Then
				SeasonList.Add(EpisodeList)
				EpisodeList.Initialize
				EpisodeList.Clear
			End If
		Else If Name = "Movie" Then
			MovieFlag = True
			CurrentSeason = 0
			InternalEpNum = 0
			If EpisodeList.Size > 0 Then
				SeasonList.Add(EpisodeList)
				EpisodeList.Initialize
				EpisodeList.Clear
			End If			
		Else If Name = "episode" Then
			EpType = ""
			EpSeason = ""
			EpNumber = ""
			EpSeasonNumber = ""
			EpProductionNumber = ""
			EpAirDate = ""
			EpLink = ""
			EpTitle = ""
			EpSummary = ""
			EpRating = ""
			EpScreenCap = ""
			EpAlternateAirTime = ""
		End If
	End If
End Sub

' EndElement </Name> - At end of each Element the Parser calls this Sub
Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
	'-----------------------------
	Dim cnt As Int
	'-----------------------------
	If WhichJob = "NameSearch" Then
		If parser.parents.IndexOf("show") > -1 Then
			Select Case Name
				Case "showid"
					ShowIdStr = Text.ToString
				Case "name"
					ShowName = Text.ToString
			End Select
		End If	
		If Name = "show" Then
			'---------------------------
			Dim ShowNameMap As Map
			'---------------------------
			ShowNameMap.Initialize
			ShowNameMap.Clear
			ShowNameMap.Put("ShowID",ShowIdStr)
			ShowNameMap.Put("ShowName",ShowName)
			ShowList.Add(ShowNameMap)			
		End If	
	Else If WhichJob = "ShowInfo" Then' Show information
		'Showinfo - showid,showname,showlink,seasons,image,started,startdate,
		'ended,origin_country,status,classification,summary,genres,
		'runtime,network,airtime,airday,timezone
		If parser.parents.IndexOf("Showinfo") > -1 Then
			If parser.parents.IndexOf("genres") > -1 Then
				genrestemp = Text.ToString
				If genres = "" Then
				 	genres = genrestemp
				Else
					genres = genres & " / " & genrestemp
				End If			
			End If
			Select Case Name	
				Case "showid"
					ShowIdStr = Text.ToString
				Case "showname"
					ShowName = Text.ToString
				Case "showlink"
					link  = Text.ToString
				Case "seasons"
					seasons = Text.ToString
				Case "image"
					image = Text.ToString
				Case "status"
					status = Text.ToString
				Case "started"
					started = Text.ToString
				Case "startdate"
					startdate = Text.ToString
				Case "summary"
					summary = Text.ToString
				' Genres are handled above
				Case "runtime"
					runtime = Text.ToString
				Case "origin_country"
					origincountry = Text.ToString
				Case "network"
					network = Text.ToString
					If origincountry <> "" Then
						network = network & " (" & origincountry & ")"
					End If
				Case "airday"
					airday  = Text.ToString
				Case "airtime"
					airtime = Text.ToString
			End Select
		End If
		If Name = "Showinfo" Then
			Dim SeriesInfoMap As Map
			SeriesInfoMap.Initialize
			SeriesInfoMap.Clear
			SeriesInfoMap.Put("ShowID",ShowIdStr)
			SeriesInfoMap.Put("ShowName",ShowName)
			SeriesInfoMap.Put("Link",link)
			SeriesInfoMap.Put("Seasons",seasons)
			SeriesInfoMap.Put("Status",status)
			SeriesInfoMap.Put("Image",image)
			SeriesInfoMap.Put("Started",started)
			SeriesInfoMap.Put("StartDate",startdate)
			SeriesInfoMap.Put("Summary",summary)
			SeriesInfoMap.Put("Genres",genres)
			SeriesInfoMap.Put("Runtime",runtime)
			SeriesInfoMap.Put("Network",network)
			SeriesInfoMap.Put("Airday",airday)
			SeriesInfoMap.Put("Airtime",airtime)
			ShowInfo.Add(SeriesInfoMap)
		End If
	Else If WhichJob = "EpisodeInfo" Then
		'---------------------------
		Dim parentsize As Int
		Dim c As Int
		'---------------------------
		parentsize = parser.Parents.Size-1
		For c = 0 To parentsize
			'Log(parser.Parents.Get(c))
		Next
'		'Log("Name = " & Name)
'		'Log("-------")
		If parser.Parents.IndexOf("Episodelist") > -1 Then
			Select Case Name
				Case "epnum"
					EpNumber = Text.ToString 
				Case "seasonnum"
					EpSeasonNumber = Text.ToString
				Case "prodnum"
					EpProductionNumber = Text.ToString
				Case "airdate"
					EpAirDate = Text.ToString
				Case "link"
					EpLink = Text.ToString
				Case "title"
					EpTitle = Text.ToString
				Case "summary"
					EpSummary = Text.ToString
				Case "rating"
					EpRating = Text.ToString
				Case "screencap"
					EpScreenCap = Text.ToString
				'------------------
				' Special/Movie specific
				'------------------
				Case "season"
					EpSeason = Text.ToString
				Case "alternatetime"
					EpAlternateAirTime = Text.ToString
			End Select
			If Name = "episode" AND parser.Parents.IndexOf("Season") > -1 Then
				Dim emap As Map
				emap.Initialize
				emap.Clear
				emap.Put("EpType","Normal")
				emap.Put("Season",CurrentSeason)
				emap.Put("SeasonNumber",EpSeasonNumber)
				emap.Put("EpisodeNumber",EpNumber)
				emap.Put("ProductionNumber",EpProductionNumber)
				emap.Put("AirDate",EpAirDate)
				emap.Put("Link",EpLink)
				emap.Put("Title",EpTitle)
				emap.Put("Summary",EpSummary)
				emap.Put("Rating",EpRating)
				emap.Put("Image",EpScreenCap)
				EpisodeList.Add(emap)
			Else If Name = "episode" AND parser.Parents.IndexOf("Special") > -1 Then
				Dim emap As Map
				emap.Initialize
				emap.Clear
				InternalEpNum = InternalEpNum + 1
				emap.Put("EpType","Special")
				emap.Put("Season",EpSeason)
				emap.Put("SeasonNumber",InternalEpNum)
				emap.Put("EpisodeNumber",InternalEpNum)
				emap.Put("ProductionNumber",EpProductionNumber)
				emap.Put("AirDate",EpAirDate)
				emap.Put("AlternateAirTime",EpAlternateAirTime)
				emap.Put("Link",EpLink)
				emap.Put("Title",EpTitle)
				emap.Put("Summary",EpSummary)
				emap.Put("Rating",EpRating)
				emap.Put("Image",EpScreenCap)
				EpisodeList.Add(emap)			
			End If
		End If
	End If
End Sub

Sub ClearElements
	'clear the page 1 information fields
	
End Sub